import 'package:zart_validator/Concerns/Zartable.dart';
import 'package:zart_validator/Rules.dart';

class ZartStructure extends Rules {
  myCustomRule(ruleString, zartable) {
    return '';
  }

  executeValidator(Zartable zartable,
      {Function(String, Zartable zartable) myCustomRule}) {
    if (zartable.rule is List)
      return iterateInRules(zartable, myCustomRule: myCustomRule);
    else {
      zartable.rule = zartable.rule.split('|');
      return iterateInRules(zartable, myCustomRule: myCustomRule);
    }
  }

  iterateInRules(Zartable zartable,
      {Function(String, Zartable zartable) myCustomRule}) {
    for (var item in zartable.rule) {
      var zartResponse =
          goForCheckRule(zartable, item, myCustomRule: myCustomRule);
      if (zartResponse is String) if (zartResponse.length > 0)
        return zartResponse;
    }
  }

  goForCheckRule(zartable, zartableRule,
      {Function(String, Zartable zartable) myCustomRule}) {
    zartable.rule = zartableRule;
    List rule = zartableRule.split(':');
    String ruleString = rule[0];
    if (myCustomRule != null) {
      String customRulesOutput = myCustomRule(ruleString, zartable);
      if (customRulesOutput != null && customRulesOutput != '')
        return customRulesOutput;
      else
        return Rules.checkRule(ruleString, zartable);
    } else
      return Rules.checkRule(ruleString, zartable);
  }
}
