import 'package:zart_validator/Rules/HaveAlpha.dart';
import 'package:zart_validator/Rules/AlphaAndNumber.dart';
import 'package:zart_validator/Rules/Between.dart';
import 'package:zart_validator/Rules/Contains.dart';
import 'package:zart_validator/Rules/Email.dart';
import 'package:zart_validator/Rules/EndWith.dart';
import 'package:zart_validator/Rules/Hex.dart';
import 'package:zart_validator/Rules/IP.dart';
import 'package:zart_validator/Rules/Max.dart';
import 'package:zart_validator/Rules/Min.dart';
import 'package:zart_validator/Rules/NotIn.dart';
import 'package:zart_validator/Rules/Numeric.dart';
import 'package:zart_validator/Rules/OnlyFloat.dart';
import 'package:zart_validator/Rules/OnlyInt.dart';
import 'package:zart_validator/Rules/OnlyNumber.dart';
import 'package:zart_validator/Rules/OnlyAlpha.dart';
import 'package:zart_validator/Rules/Regex.dart';
import 'package:zart_validator/Rules/Required.dart';
import 'package:zart_validator/Rules/StartWith.dart';
import 'package:zart_validator/Rules/Url.dart';
import 'package:zart_validator/Rules/GT.dart';
import 'package:zart_validator/Rules/GTE.dart';
import 'package:zart_validator/Rules/LT.dart';
import 'package:zart_validator/Rules/LTE.dart';
import 'package:zart_validator/Rules/In.dart';

class Rules {
  static checkRule(ruleString, zartable) {
    switch (ruleString) {
      case 'have_alpha':
        return HaveAlpha(zartable).stringValidation();
      case 'max':
        return Max(zartable).stringValidation();
      case 'min':
        return Min(zartable).stringValidation();
      case 'url':
        return Url(zartable).stringValidation();
      case 'hex':
        return Hex(zartable).stringValidation();
      case 'email':
        return Email(zartable).stringValidation();
      case 'contains':
        return Contains(zartable).stringValidation();
      case 'ip':
        return IP(zartable).stringValidation();
      case 'integer':
        return OnlyInt(zartable).stringValidation();
      case 'float':
        return OnlyFloat(zartable).stringValidation();
      case 'numeric':
        return Numeric(zartable).stringValidation();
      case 'alpha':
        return OnlyAlpha(zartable).stringValidation();
      case 'number':
        return OnlyNumber(zartable).stringValidation();
      case 'alpha_num':
        return AlphaAndNumber(zartable).stringValidation();
      case 'gt':
        return GT(zartable).stringValidation();
      case 'gte':
        return GTE(zartable).stringValidation();
      case 'lt':
        return LT(zartable).stringValidation();
      case 'lte':
        return LTE(zartable).stringValidation();
      case 'in':
        return In(zartable).stringValidation();
      case 'not_in':
        return NotIn(zartable).stringValidation();
      case 'required':
        return Required(zartable).stringValidation();
      case 'starts_with':
        return StartWith(zartable).stringValidation();
      case 'ends_with':
        return EndWith(zartable).stringValidation();
      case 'regex':
        return Regex(zartable).stringValidation();
      case 'between':
        return Between(zartable).stringValidation();
    }
  }
}
