import 'package:zart_validator/Abstracts/RuleAbstract.dart';
import 'package:zart_validator/Concerns/Zartable.dart';
import 'package:zart_validator/Rules/Numeric.dart';
import 'package:zart_validator/Rules/RuleStructure.dart';

class Between extends RuleStructure implements RuleAbstract {
  double min, max;
  String conditions;

  Between(Zartable zartableObject) : super(zartableObject) {
    conditions = rule.split(':')[1];
    min = double.parse(conditions.split(',')[0]);
    max = double.parse(conditions.split(',')[1]);
  }

  @override
  bool manualCheck() {
    if (!Numeric(zartable).boolValidation()) {
      var length = input.length;
      if (length <= max && length >= min)
        return true;
      else
        return false;
    } else {
      if (double.parse(input) >= min && double.parse(input) <= max)
        return true;
      else
        return false;
    }
  }

  @override
  dynamic customMessage() {
    return trans('between', {
      'name': name,
      'min': min.toInt().toString(),
      'max': max.toInt().toString()
    });
  }
}
