import 'package:zart_validator/Abstracts/RuleAbstract.dart';
import 'package:zart_validator/Concerns/Zartable.dart';
import 'package:zart_validator/Rules/RuleStructure.dart';

class Contains extends RuleStructure implements RuleAbstract {
  String expectedWords;
  List expectedWordsList = [];
  List leftWords = [];

  Contains(Zartable zartableObject) : super(zartableObject) {
    if (rule.contains(':'))
      expectedWords = rule.split(':')[1];
    else
      expectedWords = '';
    expectedWordsList = expectedWords.split(',');
  }

  @override
  bool manualCheck() {
    for (var item in expectedWordsList)
      if (!input.toLowerCase().contains(item)) {
        leftWords.add(item);
        return false;
      }
    return true;
  }

  @override
  dynamic customMessage() {
    return trans('contains', {'name': name, 'contains': leftWords.toString()});
  }
}
