import 'package:zart_validator/Abstracts/RuleAbstract.dart';
import 'package:zart_validator/Concerns/Zartable.dart';
import 'package:zart_validator/Rules/RuleStructure.dart';

class EndWith extends RuleStructure implements RuleAbstract {
  String expectedWords;
  List expectedWordsList = [];
  List leftWords = [];
  EndWith(Zartable zartableObject) : super(zartableObject) {
    if (rule.contains(':'))
      expectedWords = rule.split(':')[1];
    else
      expectedWords = '';
    expectedWordsList = expectedWords.split(',');
  }

  @override
  bool manualCheck() {
    for (var item in expectedWordsList)
      if (input.toLowerCase().endsWith(item.toLowerCase())) return true;
    return false;
  }

  @override
  dynamic customMessage() {
    return trans(
        'ends_with', {'name': name, 'pattern': expectedWordsList.toString()});
  }
}
