import 'package:zart_validator/Abstracts/RuleAbstract.dart';
import 'package:zart_validator/Concerns/Zartable.dart';
import 'package:zart_validator/Rules/Numeric.dart';
import 'package:zart_validator/Rules/RuleStructure.dart';

class GT extends RuleStructure implements RuleAbstract {
  double condition;

  GT(Zartable zartableObject) : super(zartableObject) {
    condition = double.parse(rule.split(':')[1]);
  }

  @override
  bool manualCheck() {
    if (Numeric(zartable).boolValidation())
      return double.parse(input) > condition.toDouble();
    else
      return false;
  }

  @override
  dynamic customMessage() {
    return trans('gt', {'name': name, 'gt': condition.toDouble().toString()});
  }
}
