import 'package:zart_validator/Abstracts/RuleAbstract.dart';
import 'package:zart_validator/Concerns/Zartable.dart';
import 'package:zart_validator/Rules/Numeric.dart';
import 'package:zart_validator/Rules/RuleStructure.dart';

class LT extends RuleStructure implements RuleAbstract {
  double condition;

  LT(Zartable zartableObject) : super(zartableObject) {
    condition = double.parse(rule.split(':')[1]);
  }

  @override
  bool manualCheck() {
    if (Numeric(zartable).boolValidation())
      return double.parse(input) < condition;
    else
      return false;
  }

  @override
  dynamic customMessage() {
    return trans('lt', {'name': name, 'lt': condition.toInt().toString()});
  }
}
