import 'package:zart_validator/Abstracts/RuleAbstract.dart';
import 'package:zart_validator/Concerns/Zartable.dart';
import 'package:zart_validator/Rules/Numeric.dart';
import 'package:zart_validator/Rules/RuleStructure.dart';

class LTE extends RuleStructure implements RuleAbstract {
  double condition;

  LTE(Zartable zartableObject) : super(zartableObject) {
    condition = double.parse(rule.split(':')[1]);
  }

  @override
  bool manualCheck() {
    if (Numeric(zartable).boolValidation())
      return double.parse(input) <= condition;
    else
      return false;
  }

  @override
  dynamic customMessage() {
    return trans('lte', {'name': name, 'lte': condition.toInt().toString()});
  }
}
