import 'package:zart_validator/Abstracts/RuleAbstract.dart';
import 'package:zart_validator/Concerns/Zartable.dart';
import 'package:zart_validator/Rules/RuleStructure.dart';

class Max extends RuleStructure implements RuleAbstract {
  double maxCondition;

  Max(Zartable zartableObject) : super(zartableObject) {
    maxCondition = double.parse(rule.split(':')[1]);
  }

  @override
  bool manualCheck() {
    if (input is String)
      return input.length <= maxCondition;
    else
      return input.toString().length <= maxCondition;
  }

  @override
  dynamic customMessage() {
    return trans('max', {'name': name, 'max': maxCondition.toInt().toString()});
  }
}
