import 'package:zart_validator/Abstracts/RuleAbstract.dart';
import 'package:zart_validator/Concerns/Zartable.dart';
import 'package:zart_validator/Rules/RuleStructure.dart';

class Min extends RuleStructure implements RuleAbstract {
  double minCondition;

  Min(Zartable zartableObject) : super(zartableObject) {
    minCondition = double.parse(rule.split(':')[1]);
  }

  @override
  bool manualCheck() {
    if (input is String)
      return input.length >= minCondition;
    else
      return input.toString().length >= minCondition;
  }

  @override
  dynamic customMessage() {
    return trans('min', {'name': name, 'min': minCondition.toInt().toString()});
  }
}
