import 'package:zart_validator/Abstracts/RuleAbstract.dart';
import 'package:zart_validator/Concerns/Zartable.dart';
import 'package:zart_validator/Rules/RuleStructure.dart';

class NotIn extends RuleStructure implements RuleAbstract {
  String allowedWords;
  List allowedWordList = [];

  NotIn(Zartable zartableObject) : super(zartableObject) {
    if (rule.contains(':'))
      allowedWords = rule.split(':')[1];
    else
      allowedWords = '';
    allowedWordList = allowedWords.split(',');
  }

  @override
  bool manualCheck() {
    return !allowedWords.contains(input);
  }

  @override
  dynamic customMessage() {
    return trans('not_in', {'name': name, 'not_in': allowedWords.toString()});
  }
}
